using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;
using Decal.Interop.Core;
using Decal.Interop.Inject;

namespace Decal.Interop.Render;

[ComImport]
[TypeLibType(4288)]
[SuppressUnmanagedCodeSecurity]
[Guid("BB70ABAC-FF03-41FE-8714-C24692C10827")]
public interface IRenderService
{
	[DispId(1610743808)]
	object Device
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[DispId(1610743808)]
		[return: MarshalAs(UnmanagedType.IUnknown)]
		get;
	}

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743809)]
	[return: MarshalAs(UnmanagedType.Interface)]
	HUDView CreateHUD([In] ref tagRECT pRegion);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743810)]
	[return: MarshalAs(UnmanagedType.Interface)]
	HUDBackground CreateBackground([In] ref tagRECT pRegion);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743811)]
	[return: MarshalAs(UnmanagedType.Interface)]
	HUDView EncapsulateHUD([In] ref tagPOINT Coords, [MarshalAs(UnmanagedType.IUnknown)] object pSurface);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743812)]
	[return: MarshalAs(UnmanagedType.Interface)]
	HUDBackground EncapsulateBackground([In] ref tagPOINT Coords, [MarshalAs(UnmanagedType.IUnknown)] object pSurface);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743813)]
	void RemoveHUD([In][MarshalAs(UnmanagedType.Interface)] HUDView pHUD);
}
